
#include <windows.h>
#include <commctrl.h>
#include <shlobj.h>
#include <stdint.h>

#include <stdio.h>
#include <string.h>
#include <signal.h>

// #define WIN32_LEAN_AND_MEAN
#define DIRECTSOUND_VERSION  0x0800
#define CINTERFACE
#include "dsound.h"

#undef LOBYTE
#undef LOWORD
#undef HIBYTE
#undef HIWORD

// #include "defs.h"

#define _UNKNOWN char
#define _BYTE char
#define _WORD short
#define _DWORD long
#define _QWORD ll
#define _LONGLONG __int128



#ifndef __cplusplus
typedef int bool; // we want to use bool in our C programs
#endif

// Some convenience macros to make partial accesses nicer
// first unsigned macros:
#define LOBYTE(x) (*((_BYTE*)&(x))) // low byte
#define LOWORD(x) (*((_WORD*)&(x))) // low word
#define LODWORD(x) (*((_DWORD*)&(x))) // low dword
#define HIBYTE(x) (*((_BYTE*)&(x)+1))
#define HIWORD(x) (*((_WORD*)&(x)+1))
#define HIDWORD(x) (*((_DWORD*)&(x)+1))
#define BYTEn(x, n) (*((_BYTE*)&(x)+n))
#define WORDn(x, n) (*((_WORD*)&(x)+n))
#define BYTE1(x) BYTEn(x, 1) // byte 1 (counting from 0)
#define BYTE2(x) BYTEn(x, 2)
#define BYTE3(x) BYTEn(x, 3)
#define BYTE4(x) BYTEn(x, 4)
#define BYTE5(x) BYTEn(x, 5)
#define BYTE6(x) BYTEn(x, 6)
#define BYTE7(x) BYTEn(x, 7)
#define BYTE8(x) BYTEn(x, 8)
#define BYTE9(x) BYTEn(x, 9)
#define BYTE10(x) BYTEn(x, 10)
#define BYTE11(x) BYTEn(x, 11)
#define BYTE12(x) BYTEn(x, 12)
#define BYTE13(x) BYTEn(x, 13)
#define BYTE14(x) BYTEn(x, 14)
#define BYTE15(x) BYTEn(x, 15)
#define WORD1(x) WORDn(x, 1)
#define WORD2(x) WORDn(x, 2) // third word of the object, unsigned
#define WORD3(x) WORDn(x, 3)
#define WORD4(x) WORDn(x, 4)
#define WORD5(x) WORDn(x, 5)
#define WORD6(x) WORDn(x, 6)
#define WORD7(x) WORDn(x, 7)

// rotate left
static int __ROL__(int value, unsigned int count)
{
  const unsigned int nbits = sizeof(int) * 8;
  int high;
  count %= nbits;

  high = value >> (nbits - count);
  value <<= count;
  value |= high;
  return value;
}

// rotate right
static int __ROR__(int value, unsigned int count)
{
  const unsigned int nbits = sizeof(int) * 8;
  int low;
  count %= nbits;

  low = value << (nbits - count);
  value >>= count;
  value |= low;
  return value;
}



int _EAX;

#define BSWAP(T) {  \
    __asm__ __volatile__ (  \
            "bswap %k0" \
            : "=q" (T)  \
            : "q" (T)); \
}

#define ASM_FNCLEX __asm("fnclex");


#define __SETO__(x, y) ((int)((x) - (y)) < 0)

#define __usercall
#define __userpurge

void ErrorOutput (void)
{
    char *errorText;

    DWORD error = GetLastError();

    // from http://stackoverflow.com/a/455533
    FormatMessage(
       // use system message tables to retrieve error text
       FORMAT_MESSAGE_FROM_SYSTEM
       // allocate buffer on local heap for error text
       |FORMAT_MESSAGE_ALLOCATE_BUFFER
       // Important! will fail otherwise, since we will not
       // (and CANNOT) pass insertion parameters
       |FORMAT_MESSAGE_IGNORE_INSERTS,
       NULL,    // unused with FORMAT_MESSAGE_FROM_SYSTEM
       error,
       MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
       (LPTSTR)&errorText,  // output
       0, // minimum size for output buffer
       NULL);   // arguments

    if ( NULL != errorText )
    {
       MessageBoxA(0, errorText, 0, 0x10u);

       // release memory allocated by FormatMessage()
       LocalFree(errorText);
       errorText = NULL;
    }
}

int32_t PSnd_Playlist_Magic = 1684951888;
int32_t PMP_Magic = 38817104;



//-------------------------------------------------------------------------
// Data declarations

int dword_401270; // weak
int dword_401288; // weak
int dword_4012B0[4]; // weak
int dword_4012C0[4]; // weak
int dword_4012D0[4]; // weak
int dword_4012E0[4]; // weak
char *aIsprocessorfea; // idb
char *ModuleName; // idb
char *SrcStr; // idb
const WCHAR word_401344; // idb
char aMicrosoftVisua[37]; // weak
char asc_4015FC[3]; // weak
char aRuntimeErrorPr[26]; // weak
char a___[4]; // weak
char aProgramNameUnk[23]; // weak
char *aGetlastactivep; // idb
char *aGetactivewindo; // idb
char *aMessageboxa; // idb
char aUser32_dll_0[11]; // idb
_UNKNOWN unk_403000; // weak
_UNKNOWN unk_403010; // weak
_UNKNOWN unk_403014; // weak
_UNKNOWN unk_40301C; // weak
_UNKNOWN unk_403020; // weak
_UNKNOWN unk_403024; // weak
_UNKNOWN unk_403028; // weak
_UNKNOWN unk_40302C; // weak
char *aTranslateaspi3; // idb
char *aFreeaspi32buff; // idb
char *aGetaspi32buffe; // idb
char *aSendaspi32comm; // idb
char *ProcName; // idb
char *LibFileName; // idb
HANDLE dword_4030A8; // idb
int dword_4030AC; // weak
int dword_4030B0; // weak
int dword_4030B4; // weak
UINT dword_4030B8; // idb
int dword_4030BC; // weak
UINT dword_4030C0; // idb
LPARAM lParam; // idb
UINT dword_4030C8; // idb
UINT dword_4030CC; // idb
int nPriority; // idb
int dword_4030D4; // weak
char byte_4030D8; // weak
char *aInvalidFile_; // idb
char *Text; // idb
char aPsoundPlaylist[29]; // weak
char *aCouldNotCreate; // idb
char aPsoundPlayli_0[28]; // weak
char aPpl[4]; // weak
char *aS05u; // idb
char aSndimage_bin[13]; // weak
char aIopvoib_bin[12]; // weak
char aBtlvoice_bin[13]; // weak
char aAf5bgm_dat[11]; // weak
char *aNotEnoughMemor; // idb
char aStop[6]; // weak
char *aD; // idb
char *aD_0; // idb
char *aLuBytes; // idb
char aXenogears[10]; // weak
char aChronocross[12]; // weak
char aCdRom[7]; // weak
char aDvdRom[8]; // weak
char *aNoDataToScanIn; // idb
char aCouldNotAccess[28]; // weak
char aCdRom_0[9]; // weak
char *String; // idb
char *aPleaseSelectAC; // idb
char *aUnrecognizedFo; // idb
char aPsound_cfg[11]; // weak
char *aInvalidFile__0; // idb
char *aDhzS; // idb
char aStereo[7]; // weak
char aMono[5]; // weak
char *aDD; // idb
char *aGimVkp_0_gim; // idb
char aEndingEnding_x[18]; // weak
char *aErrorInDirects; // idb
char *aErrorInBufferC; // idb
char *WindowName; // idb
char aConverting___[14]; // weak
char aFinished_[10]; // weak
char *aLu; // idb
char *a02d02d; // idb
char a_wav[5]; // weak
char aWaveFiles_wav[18]; // weak
char aWav[4]; // weak
char aStopped[11]; // weak
char aPlaying[11]; // weak
char aPaused[10]; // weak
char *aS_track02d; // idb
char aAudio[6]; // weak
char *a404NotFound_; // idb
char aPlayback[10]; // weak
char *aAspiInitializa; // idb
char *aCommdlg_findre; // idb
char aTitle[6]; // weak
char *aSyslistview32; // idb
char *aErrorInWindowC; // idb
char *ClassName; // idb
int WeirdValue; // weak // dword_403728
int (*off_403738)(void); // weak
int (__cdecl *off_403750)(_DWORD); // weak
int dword_403754; // weak
void *off_403758; // weak
void *off_40375C; // weak
void *off_403760; // weak
void *off_403764; // weak
void *off_403768; // weak
void *off_40376C; // weak
void *off_403778; // weak
LPVOID lpMem; // idb
int dword_403788; // weak
void **off_405798; // weak
int Heap_WTF_AlwaysZero; // weak // dword_40579C
char *byte_405828; // weak
_UNKNOWN unk_405830; // weak
int dword_405834; // weak
int dword_405838; // weak
_UNKNOWN unk_405840; // weak
_UNKNOWN unk_405920; // weak
_DWORD dword_405928[4]; // idb
int *dword_405938; // weak
LPCVOID off_40593C; // idb
int dword_4059C8; // weak
__int16 off_4059D8[2]; // weak
__int16 *word_4059E2; // weak
_UNKNOWN unk_410352; // weak
_UNKNOWN unk_410B80; // weak
_UNKNOWN unk_4114C2; // weak
_UNKNOWN unk_414050; // weak
_UNKNOWN unk_4140B0; // weak
_UNKNOWN unk_414120; // weak
_UNKNOWN unk_414140; // weak
_UNKNOWN unk_4144F0; // weak
int (__cdecl *dword_419368)(_DWORD); // weak
int dword_41936C; // weak
int dword_419370; // weak
int (*dword_419374)(void); // weak
int dword_419378; // weak
char byte_419380[4096]; // weak // HACK
CHAR MultiByteStr; // idb // const
_UNKNOWN unk_4193F0; // weak
int dword_419730; // weak
int dword_419738; // weak
int dword_41973C; // weak
int dword_419740; // weak
int dword_419744; // weak
int dword_419748; // weak
int dword_41974C; // weak
int dword_419750; // weak
char byte_419754; // weak
char byte_419755; // weak
char byte_419756; // weak
int dword_419757; // weak
char byte_41975C; // weak
__int16 word_419760; // weak
int dword_419770; // weak
int dword_419774; // weak
// struct FINDREPLACEA stru_419778; // idb
_DWORD dword_4197A0[4]; // idb
int dword_4197B0; // weak
char FileName[MAX_PATH]; // idb // const
char *byte_4198BF; // weak
char TargetFileName[MAX_PATH]; // idb // const // byte_4198C0
int dword_4198C1; // weak
int dword_4198C7; // weak
_UNKNOWN unk_4199C8; // weak
HINSTANCE hInstance; // idb
HWND MasterWindow; // idb // dword_4199DC
HWND dword_4199E0; // idb
HWND dword_4199E4; // idb
HWND hWnd; // idb
HMENU hMenu; // idb
int32_t PlaylistSize; // weak // dword_4199F0
WPARAM wParam; // idb
int dword_4199F8; // weak
HGDIOBJ ho; // idb
int dword_419A00; // weak
int dword_419A04; // weak
int dword_419A08; // weak
int dword_419A0C; // weak
int dword_419A10; // weak
int dword_419A14; // weak
int dword_419A18; // weak
LONG lDistanceToMove_global; // idb
HANDLE dword_419A20; // idb
DWORD idThread; // idb
HANDLE hHandle; // idb
int dword_419A2C; // weak
int dword_419A30; // weak
int dword_419A34; // weak
DWORD nNumberOfBytesToRead_global; // idb
UINT dword_419A3C; // idb
UINT dword_419A40; // idb
UINT dword_419A44; // idb
UINT dword_419A48; // idb
DWORD dword_419A4C; // idb
int dword_419A50; // weak
int SoundPlayingFlag; // weak // dword_419A54
LPVOID dword_419A58; // idb
DWORD dword_419A5C; // idb
int dword_419A60; // weak
int dword_419A64; // weak
LPVOID lpBuffer; // idb
int dword_419A6C; // weak
UINT uCheck; // idb
UINT uValue; // idb
int dword_419A78; // weak
int dword_419A7C; // weak
int dword_419A80; // weak
int dword_419A84; // weak
int dword_419A88; // weak
int dword_419A8C; // weak
LPARAM dword_419A90; // idb
int dword_419A94; // weak
LPARAM dword_419A98; // idb
UINT dword_419A9C; // idb
UINT dword_419AA0; // idb
UINT dword_419AA4; // idb
UINT dword_419AA8; // idb
UINT dword_419AAC; // idb
UINT dword_419AB0; // idb
UINT dword_419AB4; // idb
UINT dword_419AB8; // idb
UINT dword_419ABC; // idb
HWND hDlg; // idb
int dword_419AC4; // weak
int dword_419ACC; // weak
int dword_419AD0; // weak
UINT dword_419AD4; // idb
HWND DialogWindow; // idb // dword_419AD8
int SoundSearchFlag; // weak // dword_419ADC
int dword_419AE0; // weak
DWORD ThreadId; // idb
HANDLE hObject; // idb
int SoundSearchDialog_DisplayingStopButton; // weak // dword_419AEC
DWORD dword_419AF0; // idb
HANDLE SoundSearchThread; // idb // dword_419AF4
int dword_419AF8; // weak
int dword_419AFC; // weak
int dword_419B00; // weak
int dword_419B04; // weak
HWND dword_419B08; // idb
INT_PTR nResult; // idb
int ConversionUIFlag; // weak // dword_419B10
DWORD dword_419B14; // idb
HANDLE ConversionThread; // idb // dword_419B18
UINT_PTR uIDEvent; // idb
char byte_419B20[8]; // idb
int dword_419B28; // weak
LPVOID dword_419B48; // idb
int dword_419B50; // weak
int dword_419B70; // weak
int dword_419B74; // weak
int dword_419B7C; // weak
int dword_419B8C; // weak
char byte_419B94; // weak
int dword_419B98; // weak
int dword_419B9C; // weak
_UNKNOWN unk_419BB0; // weak
LCID Locale; // idb
int dword_419BC8; // weak
int dword_419BCC; // weak
int dword_419BD0; // weak
int (__cdecl *dword_419BD4)(_DWORD); // weak
int dword_419BDC; // weak
char Filename[264]; // idb
int dword_419CF0; // weak
_UNKNOWN unk_419CF8; // weak
char *byte_419CF9; // weak
int dword_419DFC; // weak
int dword_419E00; // weak
int dword_419E08; // weak
int dword_419E0C; // weak
int dword_419E10; // weak
int dword_419E14; // weak
int (*dword_419E18)(void); // weak
int (__stdcall *dword_419F0C)(_DWORD, _DWORD, _DWORD, _DWORD); // weak
int (*dword_419F10)(void); // weak
int (__stdcall *dword_419F14)(_DWORD); // weak
int dword_419F1C; // weak
int *dword_419F40; // weak
_UNKNOWN unk_419F44; // weak
UINT uNumber; // idb
HANDLE hHeap; // idb
int dword_41A048; // weak
int dword_41A04C; // weak
int dword_41A050; // weak




//-------------------------------------------------------------------------
// Function declarations

// #define __thiscall __cdecl // Test compile in C mode

// void __stdcall InitCommonControls();
// HWND __stdcall CreateToolbarEx(HWND hwnd, DWORD ws, UINT wID, int nBitmaps, HINSTANCE hBMInst, UINT_PTR wBMID, LPCTBBUTTON lpButtons, int iNumButtons, int dxButton, int dyButton, int dxBitmap, int dyBitmap, UINT uStructSize);
// HWND __stdcall CreateStatusWindowA(LONG style, LPCSTR lpszText, HWND hwndParent, UINT wID);
// BOOL __stdcall DeleteObject(HGDIOBJ ho);
// HFONT __stdcall CreateFontIndirectA(const LOGFONTA *lplf);
// int __stdcall GetObjectA(HANDLE h, int c, LPVOID pv);
// DWORD __stdcall GetFileSize(HANDLE hFile, LPDWORD lpFileSizeHigh);
// DWORD __stdcall SetFilePointer(HANDLE hFile, LONG lDistanceToMove, PLONG lpDistanceToMoveHigh, DWORD dwMoveMethod);
// BOOL __stdcall WriteFile(HANDLE hFile, LPCVOID lpBuffer, DWORD nNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWritten, LPOVERLAPPED lpOverlapped);
// HANDLE __stdcall CreateThread(LPSECURITY_ATTRIBUTES lpThreadAttributes, SIZE_T dwStackSize, LPTHREAD_START_ROUTINE lpStartAddress, LPVOID lpParameter, DWORD dwCreationFlags, LPDWORD lpThreadId);
// BOOL __stdcall DeleteFileA(LPCSTR lpFileName);
// BOOL __stdcall TerminateThread(HANDLE hThread, DWORD dwExitCode);
// DWORD __stdcall GetModuleFileNameA(HMODULE hModule, LPCH lpFilename, DWORD nSize);
// DWORD __stdcall GetFileAttributesA(LPCSTR lpFileName);
// HANDLE __stdcall CreateFileA(LPCSTR lpFileName, DWORD dwDesiredAccess, DWORD dwShareMode, LPSECURITY_ATTRIBUTES lpSecurityAttributes, DWORD dwCreationDisposition, DWORD dwFlagsAndAttributes, HANDLE hTemplateFile);
// BOOL __stdcall ReadFile(HANDLE hFile, LPVOID lpBuffer, DWORD nNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped);
// HANDLE __stdcall CreateEventA(LPSECURITY_ATTRIBUTES lpEventAttributes, BOOL bManualReset, BOOL bInitialState, LPCSTR lpName);
// BOOL __stdcall ResetEvent(HANDLE hEvent);
// DWORD __stdcall WaitForSingleObject(HANDLE hHandle, DWORD dwMilliseconds);
// BOOL __stdcall CloseHandle(HANDLE hObject);
// BOOL __stdcall FreeLibrary(HMODULE hLibModule);
// HMODULE __stdcall LoadLibraryA(LPCSTR lpLibFileName);
// BOOL __stdcall SetThreadPriority(HANDLE hThread, int nPriority);
// UINT __stdcall GetACP();
// LPCH __stdcall GetEnvironmentStrings();
// BOOL __stdcall FreeEnvironmentStringsW(LPWCH);
// LPWCH __stdcall GetEnvironmentStringsW();
// int __stdcall LCMapStringW(LCID Locale, DWORD dwMapFlags, LPCWSTR lpSrcStr, int cchSrc, LPWSTR lpDestStr, int cchDest);
// BOOL __stdcall FreeEnvironmentStringsA(LPCH);
// int __stdcall WideCharToMultiByte(UINT CodePage, DWORD dwFlags, LPCWSTR lpWideCharStr, int cchWideChar, LPSTR lpMultiByteStr, int cbMultiByte, LPCSTR lpDefaultChar, LPBOOL lpUsedDefaultChar);
// int __stdcall MultiByteToWideChar(UINT CodePage, DWORD dwFlags, LPCSTR lpMultiByteStr, int cbMultiByte, LPWSTR lpWideCharStr, int cchWideChar);
// int __stdcall LCMapStringA(LCID Locale, DWORD dwMapFlags, LPCSTR lpSrcStr, int cchSrc, LPSTR lpDestStr, int cchDest);
// BOOL __stdcall VirtualFree(LPVOID lpAddress, SIZE_T dwSize, DWORD dwFreeType);
// HANDLE __stdcall HeapCreate(DWORD flOptions, SIZE_T dwInitialSize, SIZE_T dwMaximumSize);
// LPVOID __stdcall VirtualAlloc(LPVOID lpAddress, SIZE_T dwSize, DWORD flAllocationType, DWORD flProtect);
// HANDLE __stdcall GetCurrentProcess();
// BOOL __stdcall HeapDestroy(HANDLE hHeap);
// void __stdcall ExitProcess(UINT uExitCode);
// BOOL __stdcall TerminateProcess(HANDLE hProcess, UINT uExitCode);
// void __stdcall GetStartupInfoA(LPSTARTUPINFOA lpStartupInfo);
// HMODULE __stdcall GetModuleHandleA(LPCSTR lpModuleName);
// LPVOID __stdcall HeapAlloc(HANDLE hHeap, DWORD dwFlags, SIZE_T dwBytes);
// BOOL __stdcall HeapFree(HANDLE hHeap, DWORD dwFlags, LPVOID lpMem);
// LPVOID __stdcall HeapReAlloc(HANDLE hHeap, DWORD dwFlags, LPVOID lpMem, SIZE_T dwBytes);
// UINT __stdcall GetOEMCP();
// UINT __stdcall SetHandleCount(UINT uNumber);
// HANDLE __stdcall GetStdHandle(DWORD nStdHandle);
// DWORD __stdcall GetFileType(HANDLE hFile);
// BOOL __stdcall GetStringTypeA(LCID Locale, DWORD dwInfoType, LPCSTR lpSrcStr, int cchSrc, LPWORD lpCharType);
// BOOL __stdcall GetCPInfo(UINT CodePage, LPCPINFO lpCPInfo);
// BOOL __stdcall GetStringTypeW(DWORD dwInfoType, LPCWSTR lpSrcStr, int cchSrc, LPWORD lpCharType);
// FARPROC __stdcall GetProcAddress(HMODULE hModule, LPCSTR lpProcName);
// BOOL __stdcall SHGetPathFromIDListA(LPCITEMIDLIST pidl, LPSTR pszPath);
// HRESULT __stdcall SHGetMalloc(IMalloc **ppMalloc);
// LPITEMIDLIST __stdcall SHBrowseForFolderA(LPBROWSEINFOA lpbi);
// HICON __stdcall LoadIconA(HINSTANCE hInstance, LPCSTR lpIconName);
// ATOM __stdcall RegisterClassExA(const WNDCLASSEXA *);
// UINT __stdcall RegisterWindowMessageA(LPCSTR lpString);
// BOOL __stdcall EnableMenuItem(HMENU hMenu, UINT uIDEnableItem, UINT uEnable);
// HWND __stdcall CreateWindowExA(DWORD dwExStyle, LPCSTR lpClassName, LPCSTR lpWindowName, DWORD dwStyle, int X, int Y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam);
// BOOL __stdcall PeekMessageA(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax, UINT wRemoveMsg);
// HACCEL __stdcall LoadAcceleratorsA(HINSTANCE hInstance, LPCSTR lpTableName);
// BOOL __stdcall InsertMenuItemA(HMENU hmenu, UINT item, BOOL fByPosition, LPCMENUITEMINFOA lpmi);
// BOOL __stdcall ShowWindow(HWND hWnd, int nCmdShow);
// BOOL __stdcall UpdateWindow(HWND hWnd);
// BOOL __stdcall InvalidateRect(HWND hWnd, const RECT *lpRect, BOOL bErase);
// LRESULT __stdcall SendDlgItemMessageA(HWND hDlg, int nIDDlgItem, UINT Msg, WPARAM wParam, LPARAM lParam);
// BOOL __stdcall DestroyWindow(HWND hWnd);
// BOOL __stdcall IsDialogMessageA(HWND hDlg, LPMSG lpMsg);
// BOOL __stdcall GetMessageA(LPMSG lpMsg, HWND hWnd, UINT wMsgFilterMin, UINT wMsgFilterMax);
// BOOL __stdcall TranslateMessage(const MSG *lpMsg);
// LRESULT __stdcall DispatchMessageA(const MSG *lpMsg);
// UINT_PTR __stdcall SetTimer(HWND hWnd, UINT_PTR nIDEvent, UINT uElapse, TIMERPROC lpTimerFunc);
// DWORD __stdcall MsgWaitForMultipleObjects(DWORD nCount, const HANDLE *pHandles, BOOL fWaitAll, DWORD dwMilliseconds, DWORD dwWakeMask);
// INT_PTR __stdcall DialogBoxParamA(HINSTANCE hInstance, LPCSTR lpTemplateName, HWND hWndParent, DLGPROC lpDialogFunc, LPARAM dwInitParam);
// HWND __stdcall SetFocus(HWND hWnd);
// BOOL __stdcall EndDialog(HWND hDlg, INT_PTR nResult);
// int wsprintfA(LPSTR, LPCSTR, ...);
// int __stdcall MessageBoxA(HWND hWnd, LPCSTR lpText, LPCSTR lpCaption, UINT uType);
// HCURSOR __stdcall SetCursor(HCURSOR hCursor);
// HCURSOR __stdcall LoadCursorA(HINSTANCE hInstance, LPCSTR lpCursorName);
// LRESULT __stdcall SendMessageA(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);
// HMENU __stdcall LoadMenuA(HINSTANCE hInstance, LPCSTR lpMenuName);
// HMENU __stdcall GetSubMenu(HMENU hMenu, int nPos);
// BOOL __stdcall SetDlgItemInt(HWND hDlg, int nIDDlgItem, UINT uValue, BOOL bSigned);
// UINT __stdcall GetDlgItemInt(HWND hDlg, int nIDDlgItem, BOOL *lpTranslated, BOOL bSigned);
// UINT __stdcall IsDlgButtonChecked(HWND hDlg, int nIDButton);
// BOOL __stdcall PostThreadMessageA(DWORD idThread, UINT Msg, WPARAM wParam, LPARAM lParam);
// BOOL __stdcall CheckDlgButton(HWND hDlg, int nIDButton, UINT uCheck);
// BOOL __stdcall KillTimer(HWND hWnd, UINT_PTR uIDEvent);
// DWORD __stdcall CheckMenuItem(HMENU hMenu, UINT uIDCheckItem, UINT uCheck);
// BOOL __stdcall RedrawWindow(HWND hWnd, const RECT *lprcUpdate, HRGN hrgnUpdate, UINT flags);
// HMENU __stdcall GetMenu(HWND hWnd);
// HWND __stdcall GetDlgItem(HWND hDlg, int nIDDlgItem);
// BOOL __stdcall SetWindowTextA(HWND hWnd, LPCSTR lpString);
// BOOL __stdcall EnableWindow(HWND hWnd, BOOL bEnable);
// int __stdcall TranslateAcceleratorA(HWND hWnd, HACCEL hAccTable, LPMSG lpMsg);
// HMENU __stdcall GetSystemMenu(HWND hWnd, BOOL bRevert);
// MMRESULT __stdcall mmioClose(HMMIO hmmio, UINT fuClose);
// HMMIO __stdcall mmioOpenA(LPSTR pszFileName, LPMMIOINFO pmmioinfo, DWORD fdwOpen);
// MMRESULT __stdcall mmioCreateChunk(HMMIO hmmio, LPMMCKINFO pmmcki, UINT fuCreate);
// LONG __stdcall mmioWrite(HMMIO hmmio, const char *pch, LONG cch);
// MMRESULT __stdcall mmioAscend(HMMIO hmmio, LPMMCKINFO pmmcki, UINT fuAscend);
int __thiscall sub_406010(int This, unsigned int a2, int a3, int a4);
signed int __thiscall sub_406240(int This);
signed int __thiscall sub_406340(int This);
signed int __thiscall sub_4063A0(int This, unsigned int a2);
signed int __thiscall sub_4063D0(int This);
bool __stdcall sub_4064A0(int a1);
signed int __thiscall sub_406500(int This, unsigned int a2, unsigned int a3, int a4, int a5, int a6);
int __fastcall sub_4065A0(int a1);
int __thiscall sub_4065C0(int This, unsigned __int8 a2);
char __thiscall sub_406600(int This);
char __thiscall sub_406610(int This);
signed int __thiscall sub_406620(int This, unsigned __int8 a2);
int __thiscall sub_406660(int This, unsigned __int8 a2);
int __thiscall sub_4066E0(int This);
signed int __thiscall sub_4066F0(int This, int a2);
signed int __thiscall sub_406790(int This, int a2, int a3, const void *a4, char a5, char a6, char a7, char a8);
// int __cdecl sub_40690C(_DWORD, _DWORD, _DWORD, _DWORD, _DWORD); // weak
signed int __cdecl AddToPlaylist(const char *, int, int, char, int); // sub_40699F
LRESULT __cdecl ActuallyRemoveFromPlaylist(WPARAM wParam); // sub_406A8F
LRESULT __cdecl RemoveAllFromPlaylist(); // sub_406AFE
LRESULT __cdecl RemoveFromPlaylist(); // sub_406B7D
signed int __cdecl LoadPlaylist(int a1, int a2); // sub_406BCF
signed int __cdecl SavePlaylist(int a1); // sub_406E2C
int __cdecl PrepareSoundName(LPSTR, int); // idb // sub_407069
signed int __cdecl strcaseequ(int a1, int a2); // sub_4070C5
WPARAM __cdecl StartAddress(int a1);
signed int __stdcall SoundSearchDialogFunc(HWND hWnd, int a2, WPARAM Parameter, int a4);
signed int __cdecl sub_40A074();
signed int __cdecl sub_40A09B(int a1);
WPARAM __cdecl sub_40A0DC();
signed int __stdcall sub_40AAE3(HWND hWnd, int a2, WPARAM Parameter, int a4);
bool __cdecl sub_40AD29();
signed int __cdecl sub_40AD6F();
signed int __cdecl sub_40ADB0();
signed int __cdecl sub_40ADEA();
signed int __cdecl sub_40B22A();
int __cdecl sub_40B43E();
signed int __cdecl sub_40B46D();
signed int __cdecl sub_40D49C();
signed int __cdecl sub_40D4B6();
int __fastcall sub_40D4C8(void *a1);
signed int __fastcall sub_40D4F9(void *a1);
signed int __cdecl sub_40D544();
signed int __cdecl sub_40FABE(void *a1, unsigned int a2);
signed int __cdecl sub_40FBB6();
bool __cdecl sub_40FC07();
int __cdecl sub_40FDD1();
int __cdecl sub_40FE0C();
int __cdecl ExtractWAV(); // sub_40FE25
signed int __stdcall sub_410104(HWND hWnd, int Parameter, unsigned __int16 a3, int a4);
signed int __cdecl sub_410386(LPARAM ppMalloc);
char __cdecl sub_410401(int a1);
signed int __cdecl FirstConvert(); // sub_410455
signed int __cdecl sub_410765(int a1);
signed int __cdecl sub_410865(int); // weak // _DWORD(_DWORD)
signed int __cdecl sub_410963();
signed int __cdecl TryPlayingSound(); // sub_4109BF
signed int __cdecl sub_410A9C();
int __cdecl sub_410C0B(HWND wParam); // idb
signed int __stdcall Configuration(signed int wParam, HWND hWnd, LRESULT a3, int a4); // sub_410CB4
signed int __stdcall sub_411274(HWND hDlg, int a2, unsigned __int16 a3, int a4);
signed int __stdcall sub_411366(HWND hDlg, LPARAM lParam, int a3, int a4);
signed int __cdecl sub_41153A(int a1, int a2);
signed int __cdecl sub_4116E6(int a1);
// int __stdcall PSnd_WindowProc(int, int, int, int); // weak // sub_411802
int __stdcall sub_412924(int a1);
// int __stdcall WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd);
LRESULT __cdecl sub_4130F3(int a1, LPARAM a2, char a3);
signed int __thiscall sub_413174(int This, int a2);
signed int __thiscall sub_4131B5(int This);
signed int __thiscall sub_4131E8(int This);
signed int __thiscall sub_41320C(int This);
signed int __thiscall sub_41325B(int This);
int __stdcall sub_413295(unsigned int a1);
// BOOL __stdcall ChooseFontA(LPCHOOSEFONTA);
// int __stdcall DirectSoundCreate8(_DWORD, _DWORD, _DWORD); weak
// int __stdcall DirectSoundEnumerateA(_DWORD, _DWORD); weak
void __thiscall FreeFromHeap_(void *This, int lpMem); // sub_4132E0
signed int __cdecl AllocFromHeapWrapKeepTrying(unsigned int a1); // sub_4133D0
int __cdecl AugmentWeirdValue(); // sub_4133F0
int __cdecl sub_413420(int a1, char a2);
int __cdecl sub_413450();
_UNKNOWN *__cdecl sub_413480();
signed __int64 __usercall double2int64 /*<edx:eax>*/(double a1/*<st0>*/); // commented // sub_4134C0
void __thiscall sub_4134F0(void *This, int a2, int a3);
int __cdecl sub_413590(int a1, unsigned __int8 a2);
int __cdecl loc_413596(int, char); // weak
void __thiscall FreeFromHeap(void *This, int lpMem); // sub_413650
signed int __cdecl sub_4136A0(unsigned int a1);
signed int __cdecl AllocFromHeapWrap(unsigned int a1, int a2); // sub_4136C0
void *__cdecl AllocFromHeap(int a1); // sub_413710
int __cdecl sub_413750(int a1, int a2);
LPCSTR __cdecl sub_4137D0(LPSTR lpMultiByteStr); // const
int __cdecl sub_413890(int a1, int a2, unsigned int a3);
bool __thiscall sub_413990(void *This, const void *lpMem, unsigned int dwBytes);
int __cdecl sub_413E00(int a1);
void __cdecl sub_413E30();
void __cdecl sub_413E60(UINT uExitCode);
void __cdecl sub_413E80(UINT uExitCode);
void __cdecl sub_413EA0(UINT uExitCode, int a2, int a3);
void __cdecl sub_413F50(unsigned int a1, unsigned int a2);
int __cdecl sub_413FB0();
bool __cdecl sub_413FD0();
bool __cdecl sub_414020();
int __thiscall sub_414590(void *This, signed int MultiByteStr);
HANDLE __cdecl sub_414690();
LPVOID __cdecl sub_4146D0();
BOOL __cdecl sub_414840(void **lpMem);
void __cdecl sub_4148A0(int a1);
int __cdecl sub_414970(unsigned int a1, int a2, int a3);
void __cdecl sub_4149D0(int a1, int a2, int a3);
int __cdecl WTF_Memory(unsigned int a1); // 
int __cdecl sub_414C70(int a1, unsigned int a2, unsigned int a3);
signed int __cdecl sub_414DF0(int a1, int a2, unsigned int a3, unsigned int a4);
bool __cdecl sub_414EC0(int a1);
signed int __cdecl sub_414EE0(LCID Locale, DWORD dwMapFlags, LPCSTR lpMultiByteStr, int lpMem, LPSTR lpDestStr, int cbMultiByte, UINT CodePage);
int __cdecl sub_415100(int a1, int a2);
signed int __cdecl sub_4153B0(unsigned __int8 a1);
signed int __cdecl sub_4153D0(unsigned __int8 a1, int a2, unsigned __int8 a3);
void __cdecl sub_415410();
int __cdecl sub_415500();
int __cdecl sub_4155A0(int a1, int a2, int a3, int a4, int a5);
void *__cdecl sub_4157B0();
signed int __cdecl sub_415910(UINT a1);
UINT __cdecl sub_415B00(UINT a1);
signed int __cdecl sub_415B50(int a1);
int __cdecl sub_415BB0();
signed int __cdecl sub_415BE0();
UINT __cdecl sub_415BF0();
int __cdecl sub_415DF0(int a1);
// int __cdecl loc_415E08(int); // weak
// int __usercall sub_415E32/*<eax>*/(int a1/*<ebp>*/, int a2, int a3);
int __userpurge sub_415EC6/*<eax>*/(int result/*<eax>*/, int a2/*<ebp>*/, int a3); 
int __cdecl sub_415FC0();
int __cdecl sub_416000(int a1);
int __cdecl sub_4161E0(int a1, int a2);
int __cdecl sub_416220(int a1, int a2);
char __cdecl sub_416240(char a1);
char __cdecl sub_4162E0(int a1);
int __thiscall sub_416370(void *This, signed int MultiByteStr, __int16 a3);
int __cdecl sub_417560(int a1, int a2, int a3);
int __cdecl sub_4175F0(DWORD dwInfoType, LPCSTR lpMultiByteStr, int cbMultiByte, LPWORD lpCharType, UINT CodePage, LCID Locale); // idb
bool __cdecl sub_4187A0(int a1, int a2);
// int __stdcall RtlUnwind(_DWORD, _DWORD, _DWORD, _DWORD); weak


BOOL __cdecl sub_40690C(int, char *, LPCTSTR, LPCTSTR, int);

